1 #!/bin/sh -- # no runable script, just for vi
5 # we all like colorful messages
6 if expr match
"$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev
/null
&& \
7 expr match
"$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev
/null
; then
8 CERROR
="\e[1;31m" # red
9 CWARNING
="\e[1;33m" # yellow
10 CMSG
="\e[1;32m" # green
11 CINFO
="\e[1;96m" # light blue
12 CDEBUG
="\e[1;94m" # blue
13 CNORMAL
="\e[0;39m" # default system console color
14 CDONE
="\e[1;32m" # green
15 CPASS
="\e[1;32m" # green
16 CFAIL
="\e[1;31m" # red
17 CCMD
="\e[1;35m" # pink
20 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
21 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgmsg
() { echo "${CMSG}$1${CNORMAL}"; }
23 msginfo
() { echo "${CINFO}I: $1${CNORMAL}"; }
24 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}"; }
25 msgdone
() { echo "${CDONE}DONE${CNORMAL}"; }
26 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
27 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}"; }
28 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}"; }
29 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}"; }
32 echo -n "${CINFO}$1${CCMD} "
33 echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} "
35 if [ -n "$1" ]; then shift; else break; fi
37 echo -n "…${CNORMAL} "
39 msgpass
() { echo "${CPASS}PASS${CNORMAL}"; }
40 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
42 if [ $# -gt 0 ]; then echo "${CFAIL}FAIL: $*${CNORMAL}" >&2;
43 else echo "${CFAIL}FAIL${CNORMAL}" >&2; fi
44 EXIT_CODE
=$((EXIT_CODE+1));
47 # enable / disable Debugging
48 MSGLEVEL
=${MSGLEVEL:-3}
49 if [ $MSGLEVEL -le 0 ]; then
52 if [ $MSGLEVEL -le 1 ]; then
56 if [ $MSGLEVEL -le 2 ]; then
60 msgpass
() { echo -n " ${CPASS}P${CNORMAL}"; }
61 msgskip
() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
62 if [ -n "$CFAIL" ]; then
63 msgfail
() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; EXIT_CODE
=$((EXIT_CODE+1)); }
65 msgfail
() { echo -n " ###FAILED###" >&2; EXIT_CODE
=$((EXIT_CODE+1)); }
68 if [ $MSGLEVEL -le 3 ]; then
72 if [ $MSGLEVEL -le 4 ]; then
77 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
78 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
79 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
80 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
81 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
84 echo "${CDONE}DONE${CNORMAL}";
89 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
92 if [ -f .
/aptconfig.conf
]; then
93 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$CMD "$@"
94 elif [ -f ..
/aptconfig.conf
]; then
95 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$CMD "$@"
97 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$CMD "$@"
100 aptconfig
() { runapt apt
-config "$@"; }
101 aptcache
() { runapt apt
-cache "$@"; }
102 aptcdrom
() { runapt apt
-cdrom "$@"; }
103 aptget
() { runapt apt
-get "$@"; }
104 aptftparchive
() { runapt apt
-ftparchive "$@"; }
105 aptkey
() { runapt apt
-key "$@"; }
106 aptmark
() { runapt apt
-mark "$@"; }
108 LD_LIBRARY_PATH
=${APTWEBSERVERBINDIR} ${APTWEBSERVERBINDIR}/aptwebserver
"$@";
111 command dpkg
--root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log
"$@"
114 if [ -f .
/aptconfig.conf
]; then
115 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} command aptitude
"$@"
116 elif [ -f ..
/aptconfig.conf
]; then
117 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} command aptitude
"$@"
119 LD_LIBRARY_PATH
=${BUILDDIRECTORY} command aptitude
"$@"
124 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} command gdb
${BUILDDIRECTORY}/$1 --args "$@"
127 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/methods
/http
130 # see apt-key for the whole trickery. Setup is done in setupenvironment
131 command gpg
--ignore-time-conflict --no-options --no-default-keyring \
132 --homedir "${TMPWORKINGDIRECTORY}/gnupghome" \
133 --no-auto-check-trustdb --trust-model always \
138 # error if we about to overflow, but ...
139 # "255 failures ought to be enough for everybody"
140 if [ $EXIT_CODE -gt 255 ]; then
141 msgdie
"Total failure count $EXIT_CODE too big"
143 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
146 shellsetedetector
() {
148 if [ "$exit_status" != '0' ]; then
149 echo >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}"
150 if [ "$EXIT_CODE" = '0' ]; then
151 EXIT_CODE
="$exit_status"
157 if [ "$1" = 'prefix' ]; then
158 CURRENTTRAP
="$2 $CURRENTTRAP"
160 CURRENTTRAP
="$CURRENTTRAP $1"
162 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
166 TMPWORKINGDIRECTORY
=$(mktemp -d)
167 TESTDIRECTORY
=$(readlink -f $(dirname $0))
168 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
170 # allow overriding the default BUILDDIR location
171 BUILDDIRECTORY
=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}
172 METHODSDIR
=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}
173 APTWEBSERVERBINDIR
=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}
174 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
177 addtrap
"cd /; rm -rf $TMPWORKINGDIRECTORY;"
178 cd $TMPWORKINGDIRECTORY
179 mkdir rootdir aptarchive keys
181 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
182 mkdir -p var
/cache var
/lib var
/log tmp
183 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
184 touch var
/lib
/dpkg
/available
186 ln -s ${BUILDDIRECTORY}/methods usr
/lib
/apt
/methods
188 local PACKAGESFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
189 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
190 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
192 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
193 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
194 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive
/Sources
196 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys
/
197 ln -s ${TMPWORKINGDIRECTORY}/keys
/joesixpack.pub rootdir
/etc
/apt
/trusted.gpg.d
/joesixpack.gpg
198 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
199 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
200 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
201 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
202 echo "Dir::Bin::Methods \"${METHODSDIR}\";" >> aptconfig.conf
203 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
204 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
205 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
206 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
207 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
208 if ! command dpkg
--assert-multi-arch >/dev
/null
2>&1; then
209 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf
# Added to test multiarch before dpkg is ready for it…
211 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
212 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
213 echo "Acquire::https::CaInfo \"${TESTDIR}/apt.pem\";" > rootdir
/etc
/apt
/apt.conf.d
/99https
214 export LC_ALL
=C.UTF
-8
215 export PATH
="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
216 configcompression
'.' 'gz' #'bz2' 'lzma' 'xz'
218 # gpg needs a trustdb to function, but it can't be invalid (not even empty)
219 # see also apt-key where this trickery comes from:
220 local TRUSTDBDIR
="${TMPWORKINGDIRECTORY}/gnupghome"
222 chmod 700 "$TRUSTDBDIR"
223 # We also don't use a secret keyring, of course, but gpg panics and
224 # implodes if there isn't one available - and writeable for imports
225 local SECRETKEYRING
="${TRUSTDBDIR}/secring.gpg"
227 # now create the trustdb with an (empty) dummy keyring
228 # newer gpg versions are fine without it, but play it safe for now
229 gpg
--quiet --check-trustdb --secret-keyring $SECRETKEYRING --keyring $SECRETKEYRING >/dev
/null
2>&1
235 if [ "$1" = "native" -o -z "$1" ]; then
236 eval `aptconfig shell ARCH APT::Architecture`
237 if [ -n "$ARCH" ]; then
240 dpkg
--print-architecture
248 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
251 configarchitecture
() {
253 echo "APT::Architecture \"$(getarchitecture $1)\";"
254 while [ -n "$1" ]; do
255 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
258 } >rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
263 if [ ! -e rootdir
/var
/lib
/dpkg
/status
]; then
264 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
265 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
266 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
268 echo -n > rootdir/var/lib/dpkg/status
271 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
272 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
273 local ARCHS="$(getarchitectures)"
274 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
275 DPKGARCH="$(dpkg --print-architecture)"
276 for ARCH in ${ARCHS}; do
277 if [ "${ARCH}" != "${DPKGARCH}" ]; then
278 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
279 # old-style used e.g. in Ubuntu-P – and as it seems travis
280 echo "DPKG
::options
:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
281 echo "DPKG
::options
:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
285 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
286 # dpkg doesn't really check the version as long as it is fully installed,
287 # but just to be sure we choose one above the required version
288 insertinstalledpackage 'dpkg' "all
" '1.16.2+fake'
294 configcompression() {
295 while [ -n "$1" ]; do
297 '.') echo ".
\t.
\tcat
";;
298 'gz') echo "gzip\tgz
\tgzip
";;
299 'bz2') echo "bzip2\tbz
2\tbzip
2";;
300 'lzma') echo "lzma
\tlzma
\txz
--format=lzma
";;
301 'xz') echo "xz
\txz
\txz
";;
302 *) echo "$1\t$1\t$1";;
305 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
308 setupsimplenativepackage() {
312 local RELEASE="${4:-unstable}"
313 local DEPENDENCIES="$5"
314 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
315 If you
find such a package installed on your system
,
316 something went horribly wrong
! They are autogenerated
317 und used only by testcases and surf no other propose…
"}"
319 local SECTION
="${7:-others}"
321 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
324 DISTSECTION
="$(echo "$SECTION" | cut -d'/' -f 1)"
326 local BUILDDIR
=incoming
/${NAME}-${VERSION}
327 mkdir -p ${BUILDDIR}/debian
/source
329 echo "* most suckless software product ever" > FEATURES
330 test -e debian
/copyright
|| echo "Copyleft by Joe Sixpack $(date +%Y)" > debian
/copyright
331 test -e debian
/changelog
|| echo "$NAME ($VERSION) $RELEASE; urgency=low
335 -- Joe Sixpack <joe@example.org> $(date -R)" > debian
/changelog
336 test -e debian
/control
|| echo "Source: $NAME
339 Maintainer: Joe Sixpack <joe@example.org>
340 Build-Depends: debhelper (>= 7)
341 Standards-Version: 3.9.1
343 Package: $NAME" > debian
/control
344 if [ "$ARCH" = 'all' ]; then
345 echo "Architecture: all" >> debian
/control
347 echo "Architecture: any" >> debian
/control
349 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian
/control
350 echo "Description: $DESCRIPTION" >> debian
/control
352 test -e debian
/compat
|| echo "7" > debian
/compat
353 test -e debian
/source
/format
|| echo "3.0 (native)" > debian
/source
/format
354 test -e debian
/rules
|| cp /usr
/share
/doc
/debhelper
/examples
/rules.tiny debian
/rules
358 buildsimplenativepackage
() {
362 local RELEASE
="${4:-unstable}"
363 local DEPENDENCIES
="$5"
364 local DESCRIPTION
="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
365 If you find such a package installed on your system,
366 something went horribly wrong! They are autogenerated
367 und used only by testcases and surf no other propose…"}"
369 local SECTION="${7:-others}"
370 local PRIORITY="${8:-optional}"
373 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
376 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
378 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
380 msgninfo "Build package
${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}…
"
381 mkdir -p $BUILDDIR/debian/source
382 echo "* most suckless software product ever
" > ${BUILDDIR}/FEATURES
384 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
386 echo "Copyleft by Joe Sixpack
$(date +%Y)" > ${BUILDDIR}/debian/copyright
387 echo "$NAME ($VERSION) $RELEASE; urgency
=low
391 -- Joe Sixpack
<joe@example.org
> $(date -R)" > ${BUILDDIR}/debian/changelog
395 Maintainer
: Joe Sixpack
<joe@example.org
>
396 Standards
-Version: 3.9.3" > ${BUILDDIR}/debian/control
397 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
398 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
400 Package
: $NAME" >> ${BUILDDIR}/debian/control
402 if [ "$ARCH" = 'all' ]; then
403 echo "Architecture
: all
" >> ${BUILDDIR}/debian/control
405 echo "Architecture
: any
" >> ${BUILDDIR}/debian/control
407 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
408 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
409 echo "Description
: $DESCRIPTION" >> ${BUILDDIR}/debian/control
411 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
412 (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \
414 echo "pool
/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
415 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
416 # gpg --yes --secret-keyring ./keys/joesixpack.sec \
417 # --keyring ./keys/joesixpack.pub --default-key 'Joe Sixpack' \
418 # --clearsign -o "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
419 # mv "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
423 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
424 rm -rf ${BUILDDIR}/debian
/tmp
425 mkdir -p ${BUILDDIR}/debian
/tmp
/DEBIAN
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
426 cp ${BUILDDIR}/debian
/copyright
${BUILDDIR}/debian
/changelog
${BUILDDIR}/FEATURES
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME}
427 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
/${NAME}-${arch}
428 if [ -n "$FILE_TREE" ]; then
429 cp -ar "$FILE_TREE" ${BUILDDIR}/debian
/tmp
432 (cd ${BUILDDIR}; dpkg
-gencontrol -DArchitecture=$arch)
433 (cd ${BUILDDIR}/debian
/tmp
; md5sum $(find usr/ -type f) > DEBIAN
/md5sums
)
434 local LOG
="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
435 # ensure the right permissions as dpkg-deb ensists
436 chmod 755 ${BUILDDIR}/debian
/tmp
/DEBIAN
437 if ! dpkg
-deb --build ${BUILDDIR}/debian
/tmp
${BUILDDIR}/..
>$LOG 2>&1; then
442 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/..
/${RELEASE}.
${DISTSECTION}.pkglist
445 mkdir -p ${BUILDDIR}/..
/${NAME}_
${VERSION}
446 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}/
447 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}.changelog
456 local ARCH
=$(getarchitecture $4)
457 local PKGNAME
="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
458 local BUILDLOG
="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
459 msgninfo
"Build package ${PKGNAME} for ${RELEASE} in ${SECTION}… "
461 if [ "$ARCH" = "all" ]; then
462 ARCH
="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
464 if ! dpkg
-buildpackage -uc -us -a$ARCH >$BUILDLOG 2>&1 ; then
468 local PKGS
="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")"
469 local SRCS
="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')"
472 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.pkglist
475 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.srclist
481 if [ -d incoming
]; then
482 buildaptarchivefromincoming
"$@"
484 buildaptarchivefromfiles
"$@"
488 createaptftparchiveconfig
() {
489 local COMPRESSORS
="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
490 COMPRESSORS
="${COMPRESSORS%* }"
491 local ARCHS
="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
492 if [ -z "$ARCHS" ]; then
493 # the pool is empty, so we will operate on faked packages - let us use the configured archs
494 ARCHS
="$(getarchitectures)"
497 ArchiveDir "' >> ftparchive.conf
498 echo -n $(readlink -f .) >> ftparchive.conf
500 CacheDir "' >> ftparchive.conf
501 echo -n $(readlink -f ..) >> ftparchive.conf
503 FileListDir "' >> ftparchive.conf
504 echo -n $(readlink -f pool/) >> ftparchive.conf
508 Packages::Compress "'"$COMPRESSORS"'";
509 Sources::Compress "'"$COMPRESSORS"'";
510 Contents::Compress "'"$COMPRESSORS"'";
511 Translation::Compress "'"$COMPRESSORS"'";
512 LongDescription "false";
516 SrcDirectory "pool/";
522 Label "apttestcases";
524 Description "repository with dummy packages";
525 Architectures "' >> ftparchive.conf
526 echo -n "$ARCHS" >> ftparchive.conf
530 };' >> ftparchive.conf
531 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
532 echo -n 'tree "dists/' >> ftparchive.conf
533 echo -n "$DIST" >> ftparchive.conf
535 Architectures "' >> ftparchive.conf
536 echo -n "$ARCHS" >> ftparchive.conf
538 FileList "' >> ftparchive.conf
539 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
541 SourceFileList "' >> ftparchive.conf
542 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
544 Sections "' >> ftparchive.conf
545 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
547 };' >> ftparchive.conf
551 buildaptftparchivedirectorystructure
() {
552 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
553 for DIST
in $DISTS; do
554 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
555 for SECTION
in $SECTIONS; do
556 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
557 for ARCH
in $ARCHS; do
558 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
560 mkdir -p dists
/${DIST}/${SECTION}/source
561 mkdir -p dists
/${DIST}/${SECTION}/i18n
571 local DEPENDENCIES
="$5"
572 local PRIORITY
="${6:-optional}"
573 local DESCRIPTION
="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
574 If you find such a package installed on your system,
575 something went horribly wrong! They are autogenerated
576 und used only by testcases and surf no other propose…"}"
578 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
579 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
580 ARCHS
="$(getarchitectures)"
584 for BUILDARCH
in $ARCHS; do
585 local PPATH
="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
586 mkdir -p $PPATH aptarchive
/dists
/${RELEASE}/main
/source
587 touch aptarchive
/dists
/${RELEASE}/main
/source
/Sources
588 local FILE
="${PPATH}/Packages"
593 Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
594 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
595 echo "Version: $VERSION
596 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
597 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
598 echo "Description: $DESCRIPTION" >> $FILE
609 local DEPENDENCIES
="$5"
611 local SPATH
="aptarchive/dists/${RELEASE}/main/source"
613 local FILE
="${SPATH}/Sources"
617 Maintainer: Joe Sixpack <joe@example.org>
618 Architecture: $ARCH" >> $FILE
619 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
621 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
622 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
626 insertinstalledpackage
() {
630 local DEPENDENCIES
="$4"
631 local PRIORITY
="${5:-optional}"
632 local STATUS
="${6:-install ok installed}"
633 local DESCRIPTION
="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
634 If you find such a package installed on your system,
635 something went horribly wrong! They are autogenerated
636 und used only by testcases and surf no other propose…"}"
638 local FILE='rootdir/var/lib/dpkg/status'
639 local INFO='rootdir/var/lib/dpkg/info'
640 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
646 Maintainer: Joe Sixpack <joe@example.org>
647 Version: $VERSION" >> $FILE
648 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
649 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
650 echo "Description: $DESCRIPTION" >> $FILE
652 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
653 echo -n > ${INFO}/${NAME}:${arch}.list
655 echo -n > ${INFO}/${NAME}.list
661 buildaptarchivefromincoming
() {
662 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
664 [ -e pool
] || ln -s ..
/incoming pool
665 [ -e ftparchive.conf
] || createaptftparchiveconfig
666 [ -e dists
] || buildaptftparchivedirectorystructure
667 msgninfo
"\tGenerate Packages, Sources and Contents files… "
668 aptftparchive
-qq generate ftparchive.conf
674 buildaptarchivefromfiles
() {
675 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
676 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
677 msgninfo
"\t${line} file… "
678 compressfile
"$line" "$1"
681 generatereleasefiles
"$@"
685 cat ${TMPWORKINGDIRECTORY}/rootdir
/etc
/testcase
-compressor.conf
| while read compressor extension
command; do
686 if [ "$compressor" = '.' ]; then
692 cat "$1" | $command > "${1}.${extension}"
694 touch -d "$2" "${1}.${extension}"
699 # can be overridden by testcases for their pleasure
700 getcodenamefromsuite
() {
702 unstable
) echo 'sid';;
706 getreleaseversionfromsuite
() { true
; }
707 getlabelfromsuite
() { true
; }
709 generatereleasefiles
() {
710 # $1 is the Date header and $2 is the ValidUntil header to be set
711 # both should be given in notation date/touch can understand
712 msgninfo
"\tGenerate Release files… "
713 if [ -e aptarchive
/dists
]; then
714 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
715 local SUITE
="$(echo "$dir" | cut -d'/' -f 4)"
716 local CODENAME
="$(getcodenamefromsuite $SUITE)"
717 local VERSION
="$(getreleaseversionfromsuite $SUITE)"
718 local LABEL
="$(getlabelfromsuite $SUITE)"
719 if [ -n "$VERSION" ]; then
720 VERSION
="-o APT::FTPArchive::Release::Version=${VERSION}"
722 if [ -n "$LABEL" ]; then
723 LABEL
="-o APT::FTPArchive::Release::Label=${LABEL}"
725 aptftparchive
-qq release
$dir \
726 -o APT
::FTPArchive
::Release
::Suite
="${SUITE}" \
727 -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" \
730 | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
731 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
733 NotAutomatic: yes' $dir/Release
735 if [ -n "$1" -a "$1" != "now" ]; then
736 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
740 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
744 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
746 if [ -n "$1" -a "$1" != "now" ]; then
747 for release
in $(find ./aptarchive -name 'Release'); do
748 touch -d "$1" $release
754 setupdistsaptarchive
() {
755 local APTARCHIVE
=$(readlink -f ./aptarchive)
756 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
757 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
758 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
759 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
760 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
761 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
762 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
767 setupflataptarchive
() {
768 local APTARCHIVE
=$(readlink -f ./aptarchive)
769 if [ -f ${APTARCHIVE}/Packages
]; then
770 msgninfo
"\tadd deb sources.list line… "
771 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
774 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
776 if [ -f ${APTARCHIVE}/Sources
]; then
777 msgninfo
"\tadd deb-src sources.list line… "
778 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
781 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
787 if [ -e aptarchive
/dists
]; then
793 if [ "$1" != '--no-update' ]; then
794 msgninfo
"\tSync APT's cache with the archive… "
801 local SIGNER
="${1:-Joe Sixpack}"
802 local GPG
="gpg --batch --yes"
803 msgninfo
"\tSign archive with $SIGNER key… "
804 local REXKEY
='keys/rexexpired'
805 local SECEXPIREBAK
="${REXKEY}.sec.bak"
806 local PUBEXPIREBAK
="${REXKEY}.pub.bak"
807 if [ "${SIGNER}" = 'Rex Expired' ]; then
808 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
809 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
810 # therefore we 'temporary' make the key not expired and restore a backup after signing
811 cp ${REXKEY}.sec
$SECEXPIREBAK
812 cp ${REXKEY}.pub
$PUBEXPIREBAK
813 local SECUNEXPIRED
="${REXKEY}.sec.unexpired"
814 local PUBUNEXPIRED
="${REXKEY}.pub.unexpired"
815 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
816 cp $SECUNEXPIRED ${REXKEY}.sec
817 cp $PUBUNEXPIRED ${REXKEY}.pub
819 printf "expire\n1w\nsave\n" | $GPG --keyring ${REXKEY}.pub
--secret-keyring ${REXKEY}.sec
--command-fd 0 --edit-key "${SIGNER}" >/dev
/null
2>&1 || true
820 cp ${REXKEY}.sec
$SECUNEXPIRED
821 cp ${REXKEY}.pub
$PUBUNEXPIRED
824 for KEY
in $(find keys/ -name '*.sec'); do
825 GPG
="$GPG --secret-keyring $KEY"
827 for KEY
in $(find keys/ -name '*.pub'); do
828 GPG
="$GPG --keyring $KEY"
830 for RELEASE
in $(find aptarchive/ -name Release); do
831 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg
${RELEASE}
832 local INRELEASE
="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
833 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
834 # we might have set a specific date for the Release file, so copy it
835 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg
${INRELEASE}
837 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
838 mv -f $SECEXPIREBAK ${REXKEY}.sec
839 mv -f $PUBEXPIREBAK ${REXKEY}.pub
845 msgtest
"Set webserver config option '${1}' to" "$2"
846 downloadfile
"http://localhost:8080/_config/set/${1}/${2}" '/dev/null' >/dev
/null
847 local DOWNLOG
='download-testfile.log'
849 local STATUS
="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.status"
850 downloadfile
"http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG"
851 if [ "$(cat "$STATUS")" = '200' ]; then
855 msgfail
"Statuscode was $(cat "$STATUS")"
860 rewritesourceslist
() {
861 local APTARCHIVE
="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
862 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
863 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#http://localhost:4433/#${1}#"
867 changetowebserver
() {
868 if [ "$1" != '--no-rewrite' ]; then
869 rewritesourceslist
'http://localhost:8080/'
873 if test -x ${APTWEBSERVERBINDIR}/aptwebserver
; then
875 if ! aptwebserver
-o aptwebserver
::fork
=1 "$@" >webserver.log
2>&1 ; then
879 local PID
="$(cat aptwebserver.pid)"
880 if [ -z "$PID" ]; then
881 msgdie
'Could not fork aptwebserver successfully'
886 msgdie
'You have to build aptwerbserver or install a webserver'
890 changetohttpswebserver
() {
891 if ! which stunnel4
>/dev
/null
; then
892 msgdie
'You need to install stunnel4 for https testcases'
894 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
895 changetowebserver
--no-rewrite
897 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
898 cert = ${TESTDIRECTORY}/apt.pem
904 " > ${TMPWORKINGDIRECTORY}/stunnel.conf
905 stunnel4
"${TMPWORKINGDIRECTORY}/stunnel.conf"
906 local PID
="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
907 addtrap
'prefix' "kill ${PID};"
908 rewritesourceslist
'https://localhost:4433/'
912 mkdir -p rootdir
/media
/cdrom
/.disk
913 local CD
="$(readlink -f rootdir/media/cdrom)"
914 echo "acquire::cdrom::mount \"${CD}\";" > rootdir
/etc
/apt
/apt.conf.d
/00cdrom
915 echo 'acquire::cdrom::autodetect 0;' >> rootdir
/etc
/apt
/apt.conf.d
/00cdrom
916 echo -n "$1" > ${CD}/.disk
/info
917 if [ ! -d aptarchive
/dists
]; then
918 msgdie
'Flat file archive cdroms can not be created currently'
921 mv aptarchive
/dists
$CD
922 ln -s "$(readlink -f ./incoming)" $CD/pool
923 find rootdir
/etc
/apt
/sources.list.d
/ -name 'apt-test-*.list' -delete
927 PROTO
="$(echo "$1" | cut -d':' -f 1)"
928 local DOWNLOG
="${TMPWORKINGDIRECTORY}/download.log"
932 echo "601 Configuration
933 Config-Item: Acquire::https::CaInfo=${TESTDIR}/apt.pem
934 Config-Item: Debug::Acquire::${PROTO}=1
940 # simple worker keeping stdin open until we are done (201) or error (400)
941 # and requesting new URIs on try-agains/redirects inbetween
942 { tail -n 999 -f "$DOWNLOG" & echo "TAILPID: $!"; } | while read f1 f2
; do
943 if [ "$f1" = 'TAILPID:' ]; then
945 elif [ "$f1" = 'New-URI:' ]; then
946 echo "600 Acquire URI
950 elif [ "$f1" = '201' ] || [ "$f1" = '400' ]; then
951 # tail would only die on next read – which never happens
952 test -z "$TAILPID" || kill -s HUP
"$TAILPID"
956 } | LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/methods
/${PROTO} 2>&1 | tee "$DOWNLOG"
958 # only if the file exists the download was successful
967 local DIFFTEXT
="$(command diff -u "$@" | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
968 if [ -n "$DIFFTEXT" ]; then
980 msgtest
"Test for correctness of file" "$FILE"
982 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
984 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
989 msgtest
"Test for no output of" "$*"
990 test -z "$($* 2>&1)" && msgpass
|| msgfail
994 local COMPAREFILE
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
995 echo "$1" > $COMPAREFILE
997 msgtest
"Test for equality of" "$*"
998 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
1002 local COMPAREFILE1
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1003 local COMPAREFILE2
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1004 local COMPAREAGAINST
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
1005 echo "$1" > $COMPAREFILE1
1006 echo "$2" > $COMPAREFILE2
1008 msgtest
"Test for equality OR of" "$*"
1009 $
* >$COMPAREAGAINST 2>&1 || true
1010 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
1011 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
1012 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
1013 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
1018 local VIRTUAL
="N: Can't select versions from package '$1' as it is purely virtual"
1021 while [ -n "$1" ]; do
1023 N: Can't select versions from package '$1' as it is purely virtual"
1024 PACKAGE
="${PACKAGE} $1"
1027 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
1029 N: No packages found"
1030 local COMPAREFILE
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
1031 local ARCH
="$(getarchitecture 'native')"
1032 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
1033 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
1037 msgtest
"Test for non-existent packages" "apt-cache show $*"
1038 local SHOWPKG
="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
1039 if [ -n "$SHOWPKG" ]; then
1048 testdpkginstalled
() {
1049 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
1050 local PKGS
="$(dpkg -l "$@" 2>/dev/null | grep '^i' | wc -l)"
1051 if [ "$PKGS" != $# ]; then
1053 dpkg
-l "$@" | grep '^[a-z]'
1060 testdpkgnotinstalled
() {
1061 msgtest
"Test for correctly not-installed package(s) with" "dpkg -l $*"
1062 local PKGS
="$(dpkg -l "$@" 2> /dev/null | grep '^i' | wc -l)"
1063 if [ "$PKGS" != 0 ]; then
1065 dpkg
-l "$@" | grep '^[a-z]'
1073 local COMPAREFILE
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
1074 if [ -n "$1" ]; then
1075 msgtest
'Test for correctly marked as auto-installed' "$*"
1076 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1078 msgtest
'Test for correctly marked as auto-installed' 'no package'
1079 echo -n > $COMPAREFILE
1081 aptmark showauto
2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
1085 if [ "$1" = '--nomsg' ]; then
1088 msgtest
'Test for successful execution of' "$*"
1090 local OUTPUT
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
1091 if $@
>${OUTPUT} 2>&1; then
1101 if [ "$1" = '--nomsg' ]; then
1104 msgtest
'Test for failure in execution of' "$*"
1106 local OUTPUT
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1107 if $@
>${OUTPUT} 2>&1; then
1117 echo "STOPPED execution. Press enter to continue"